#! /bin/bash
# BitlBee install script for Slackware by martijn@inlv.org
# Generated by bitlbee.SlackBuild for bitlbee-1.0.3-i486-1McD.tgz on 10-Jul-2006

upd_conf() {
 	# If there's no config file by that name, mv it over:
 	if ! test -f $1; then
 		mv $1.new $1
 	elif diff --brief $1 $1.new; then	# toss the redundant copy
 		rm $1.new
 	fi
 	# Otherwise, we leave the .new copy for the admin to consider...
}

# Update configuration files
{
	upd_conf etc/bitlbee/bitlbee.conf
	upd_conf etc/bitlbee/motd.txt
} | sed 's/^/[1mConfig alert: [0m/'

function free_user_id {
 	# Find a free user-ID >= 100 (should be < 1000 so it's not a normal user)
 	local FREE_USER_ID=100
 	while grep -q "^.*:.*:$FREE_USER_ID:.*:.*:.*:" /etc/passwd; do
 		let FREE_USER_ID++
 	done
 	echo $FREE_USER_ID
}

# Set up group
grep --silent '^daemon:' etc/group || groupadd daemon

# Set up user: add it if it doesn't exist, update it if it already does.
# In any case, make sure it has or gets a user ID between 100 and 999.
echo "Setting up unprivileged user 'bitlbee' to run the daemon."
if EXISTING_ENTRY=$(grep '^bitlbee:' /etc/passwd); then
 	ACTION=mod				# Modify existing user
 	USER_ID=$(echo $EXISTING_ENTRY | cut --fields=3 --delimiter=':')
 	if test $USER_ID -ge 1000; then	# Modify existing uid if >= 1000
 		USER_ID=$(free_user_id)
 	fi
else
 	ACTION=add				# Add non-existent user
 	USER_ID=$(free_user_id)
fi
user$ACTION -g daemon -d /var/lib/bitlbee -c "BitlBee IRC-to-IM Gateway Daemon" \
 	-u $USER_ID -s /bin/false bitlbee

# Set up permissions
chown -R bitlbee:daemon var/lib/bitlbee

# add BitlBee to /etc/inetd.conf; comment it out if a port 6667 service is already present.
if ! test -f etc/inetd.conf; then
 	echo "[1;31mWarning:[0m inetd is not installed, bitlbee cannot be used normally."
 	echo "	 Install inetd, then reinstall this package."
elif ( ! grep --silent "^6667.*/usr/sbin/bitlbee$" etc/inetd.conf ) &&
     ( ! grep --silent "^ircd.*/usr/sbin/bitlbee$" etc/inetd.conf ); then
echo "Adding BitlBee to /etc/inetd.conf"
 	echo "# BitlBee IRC-IM gateway:" >>etc/inetd.conf
 	if ( grep --silent "^6667" etc/inetd.conf ) ||
 	   ( grep --silent "^ircd" etc/inetd.conf ); then
 		echo -n "#" >>etc/inetd.conf
 		echo "[1;31mWarning: [1;34mCommenting out BitlBee in /etc/inetd.conf because another service[0m"
 		echo "[1;34mis already using the ircd port. Edit /etc/inetd.conf, and then[0m"
 	fi
 	echo "ircd stream tcp nowait bitlbee /usr/sbin/tcpd /usr/sbin/bitlbee" >>etc/inetd.conf
 	echo "[1;34mRestart inetd to use BitlBee:  [1;31m# [1;32m/etc/rc.d/rc.inetd restart[0m"
else
echo "BitlBee is already in /etc/inetd.conf"
fi

# Make symlinks (generated by makepkg)
